<?php

class Centralpay3dsModuleFrontController extends ModuleFrontController
{

    public $module;
    const ACSURL ='acsURL';
    const PAREQ='paReq';

    public function __construct()
    {
        $this->controller_type = 'modulefront'; //instead of standard controllers’ front

        $this->module = Module::getInstanceByName(Tools::getValue('module')); // an instance of the module is created
        if (!$this->module->active) {
          Tools::redirect('index'); //if the module is inactive, the user will be redirected to index.php
        }
        $this->page_name = 'module-'.$this->module->name.'-'.Dispatcher::getInstance()->getController(); //for example: module-belvg_storelocator-search

        parent::__construct();
    }




    public function postProcess()
    {



    }
    /**
     * Assign template vars related to page content
     * @see FrontController::initContent()
     */
    public function initContent()
    {

        $this->disableColumns();
        parent::initContent();

        $retour = json_decode($this->context->cookie->retour3DS, 1);
        if(isset($retour[self::ACSURL]) && $retour[self::ACSURL]==''){
          $condition1 = true;
        }else{
          $condition1 = false;
        }


        if(!isset($retour[self::ACSURL]) || !isset($retour[self::PAREQ]) || $condition1 || (isset($retour[self::PAREQ]) && $retour[self::ACSURL]=='')){

            //on transforme le panier en commande erreur de paiement
            $link = $this->errorCommande();

            Tools::redirect($link);
            exit();
        }


        $this->context->smarty->assign(
            array(
                self::PAREQ =>$retour[self::PAREQ],
              self::ACSURL=>$retour[self::ACSURL],
                'merchant_description'=>$retour['merchantName'],
                'retour'=>$this->context->link->getModuleLink('centralpay','3dsretour')

            )
        );
        return $this->setTemplate('module:centralpay/views/templates/front/3ds.tpl');

    }


    protected function getModuleDir($data=null)
    {
        $path = _PS_MODULE_DIR_.$this->module->name.'/views/templates/front/';
        if(!is_null($data)){
            return _PS_MODULE_DIR_.$this->module->name.'/views/templates/front/'.$data.'/';
        }

        if(!is_null($data)) {
          throw new PrestaShopException('Template not mapped');
        }
        return $path;
    }

    protected function disableColumns()
    {
        $this->display_column_left = false;
        $this->display_column_right = false;
        $this->display_footer = false;
        $this->display_header = false;
    }

  public function errorCommande() {


    $link = $this->context->link->getModuleLink('centralpay', 'error');
    Tools::redirect($link);
    exit();


  }

}