<?php

class Centralpay3dsiframeModuleFrontController extends ModuleFrontController {

  public $module;

  public function __construct() {
    $this->controller_type = 'modulefront'; //instead of standard controllers’ front

    $this->module = Module::getInstanceByName(Tools::getValue('module')); // an instance of the module is created
    if (!$this->module->active) {
      Tools::redirect('index'); //if the module is inactive, the user will be redirected to index.php
    }
    $this->page_name = 'module-' . $this->module->name . '-' . Dispatcher::getInstance()
        ->getController(); //for example: module-belvg_storelocator-search

    parent::__construct();
  }


  public function postProcess() {


  }

  /**
   * Assign template vars related to page content
   *
   * @see FrontController::initContent()
   */
  public function initContent() {

    $this->disableColumns();
    parent::initContent();


    $this->context->smarty->assign(
      [
        'url' => $this->context->link->getModuleLink('centralpay', '3ds'),

      ]
    );
    return $this->setTemplate('module:centralpay/views/templates/front/3dsiframe.tpl');

  }


  protected function getModuleDir($data = NULL) {
    $path = _PS_MODULE_DIR_ . $this->module->name . '/views/templates/front/';
    if (!is_null($data)) {
      return _PS_MODULE_DIR_ . $this->module->name . '/views/templates/front/' . $data . '/';
    }

    if (!is_null($data)) {
      throw new PrestaShopException('Template not mapped');
    }
    return $path;
  }

  protected function disableColumns() {
    $this->display_column_left = FALSE;
    $this->display_column_right = FALSE;
    $this->display_footer = TRUE;
    $this->display_header = TRUE;
  }


}