<?php

class CentralpayCardProcessModuleFrontController extends ModuleFrontController {

  protected $msg = "";

  protected $title = "";

  const CENTRALPAY = '_CENTRALPAY_';

  const CUSTOMER_ID = 'customerId';

  const CURRENCY = 'currency';

  const AMOUNT ='amount';

  const SAVE_CARD = 'saveCard';

  const HTTP_CODE = 'http_code';

  const CARD_ID ='cardId';

  const TRANSACTION = 'transaction';

  const CHECK_ENROLLMENT ='checkEnrollment';

  const RETOUR_3DS ='retour3DS';

  const NOM_MODULE = 'centralpay';

  const CUSTOMER_VALIDATION_VALUE ='customerValidationValue';

  public function postProcess() {

    $this->context->cookie->__unset(self::TRANSACTION);
    $this->context->cookie->__unset(self::CARD_ID);
    $this->context->cookie->__unset(self::CUSTOMER_VALIDATION_VALUE);
    $this->context->cookie->__unset(self::RETOUR_3DS);
    $this->context->cookie->__unset('opt');
    $this->context->cookie->__unset('cvc');


    $hasError = FALSE;
    $sql = 'SELECT * FROM ' . _DB_PREFIX_ . 'module WHERE name=\'' . pSQL(self::NOM_MODULE) . '\'';
    $results = Db::getInstance()->ExecuteS($sql);


    if (Configuration::get(self::CENTRALPAY . 'MODE_TEST') == 1) {
      $url_api = API_TEST;

    }
    else {
      $url_api = API;

    }
    $cardId = Tools::getValue(self::CARD_ID);

    $customerValidationValue = Tools::getValue(self::CUSTOMER_VALIDATION_VALUE);

    $id_module = $results[0]["id_module"];
    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = Configuration::get(self::CENTRALPAY . 'LOGIN') . ":" . Configuration::get(self::CENTRALPAY . 'PASSWORD');

    /**
     * ADRESSE IP DU CLIENT
     */
    if (Configuration::get(self::CENTRALPAY . 'MODE_TEST') == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = Configuration::get(self::CENTRALPAY . 'IP');
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }


    $panier = $this->context->cart;

    $sql = 'SELECT ' . self::CUSTOMER_ID . ' FROM ' . _DB_PREFIX_ . 'centralpay_card WHERE cardId=\'' . pSQL($cardId) . '\'';
    $results = Db::getInstance()->ExecuteS($sql);
    if (isset($results[0]) && $results[0][self::CUSTOMER_ID] != '') {

      $customerid = $results[0][self::CUSTOMER_ID];


      /**
       * Si paiement configuré pour le 3DS
       */
      if (!$hasError && Configuration::get(self::CENTRALPAY . '3DS') == 1 && Configuration::get(self::CENTRALPAY . 'FORCE3DS') == 1) {

        $currency = new Currency($panier->id_currency);
        $address = new Address($this->context->cart->id_address_delivery);

        $country = new Country($address->id_country);

        $enrolement['merchantTransactionIdentifier'] = $this->context->cart->id;
        $enrolement['merchantName'] = Configuration::get('PS_SHOP_NAME');
        $enrolement['merchantCountry'] = $country->iso_code;
        $enrolement['merchantURL'] = $_SERVER["REQUEST_SCHEME"] . '://' . $_SERVER["HTTP_HOST"];
        $enrolement[self::CURRENCY] = $currency->iso_code;
        $enrolement[self::AMOUNT] = intval($panier->getordertotal(FALSE) * 100);
        $enrolement[self::CUSTOMER_ID] = $customerid;
        $enrolement[self::CARD_ID] = $cardId;


        $enrolementfields = isset($enrolement) ? http_build_query($enrolement) : NULL;
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url_api .self::CHECK_ENROLLMENT);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $enrolementfields);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
        $result = curl_exec($curl);
        $info = curl_getinfo($curl);
        $retour = json_decode($result, 1);
        curl_close($curl);

        //erreur sur le retour de l'appel à l'api
        if (isset($retour["statuts"]) && $retour["statuts"] == 'FAILURE') {
          $link = $this->errorCommande();
          Tools::redirect($link);
          $retour["url"] = $link;
          $retour["success"] = FALSE;

          exit();

        }

        $this->context->cookie->__set(self::RETOUR_3DS, $result);
        $this->context->cookie->__set(self::CARD_ID, $cardId);
        $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
        $link = $this->context->link->getModuleLink(self::NOM_MODULE, '3dsiframe');

        Tools::redirect($link);

        exit();

      }

      global $cookie;
      $iso_code = Language::getIsoById( (int)$cookie->id_lang );
      $currency = new Currency($panier->id_currency);

      $trans[self::CURRENCY] = $currency->iso_code;
      $trans[self::AMOUNT] = intval($panier->getordertotal(TRUE) * 100);
      $trans[self::CUSTOMER_ID] = $customerid;
      $trans[self::CARD_ID] = $cardId;
      $trans[self::CUSTOMER_VALIDATION_VALUE] = $customerValidationValue;
      $trans['endUserLanguage']=$iso_code;
      $trans['merchantTransactionId'] = $panier->id;
      $trans['pointOfSaleId'] = Configuration::get(self::CENTRALPAY . 'POINTOFSALEID');
      $trans['endUserIp'] = $adresse_ip;
      if(Configuration::get(self::CENTRALPAY . 'FORCECVC')==1){

        $trans["cvcValidation"]= Tools::getValue('customerValidationValue');
      }
      $transfields = isset($trans) ? http_build_query($trans) : NULL;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, $url_api . self::TRANSACTION);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);

      $retour = json_decode($result, 1);
      curl_close($curl);

      /**
       * Vérification de l'état de la transaction
       */

      if (isset($info[self::HTTP_CODE]) && $info[self::HTTP_CODE] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
        //transaction ok
        //on transforme le panier en commande validée et payée
        $cart = new Cart((int) $panier->id);
        $order_status = (int) Configuration::get('PS_OS_PAYMENT');
        $order_total = $cart->getOrderTotal(TRUE, Cart::BOTH);
        $this->module->validateOrder($panier->id, $order_status, $order_total, $this->module->l("CentralPay payment", 'cardprocess'), NULL, ['transaction_id' => $retour["transactionId"]], NULL, FALSE, $panier->secure_key);
        /**
         * Enregistrement de la liaison entre le paiement et la carte centralpay
         */
        $orderid = Order::getOrderByCartId((int) ($cart->id));

        $order = new Order($orderid);

        $sql = 'SELECT * FROM ' . _DB_PREFIX_ . 'order_payment WHERE order_reference=\'' . pSQL($order->reference) . '\'';
        $results = Db::getInstance()->ExecuteS($sql);
        if (is_array($results)) {
          foreach ($results as $r) {
            if ($r["transaction_id"] == $retour["transactionId"]) {
              Db::getInstance()->insert('centralpay_payment_card', [
                self::CARD_ID => pSQL($cardId),
                'cmsPaymentId' => pSQL($r["id_order_payment"]),
              ]);


            }


          }


        }

        $link = 'index.php?controller=order-confirmation&id_cart=' . $order->id_cart
          . '&id_module=' . $id_module . '&id_order=' . $order->id
          . '&key=' . $order->secure_key;
        Tools::redirect($link);

      }
      elseif (isset($info[self::HTTP_CODE]) && $info[self::HTTP_CODE] == 307) {
        //on vérifie si on doit faire une transtion pas 3ds
        // si opt est à false et checkrenfollment alors 3ds


        $retour = json_decode($result, 1);
        if (is_array($retour[self::CHECK_ENROLLMENT])) {
          $this->context->cookie->__set(self::RETOUR_3DS, json_encode($retour[self::CHECK_ENROLLMENT]));
          $this->context->cookie->__set(self::CARD_ID, $cardId);
          $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
          $this->context->cookie->__set(self::SAVE_CARD, Tools::getValue(self::SAVE_CARD));
          $this->context->cookie->__set(self::TRANSACTION, json_encode($trans));
          if (isset($retour["otp"]) && $retour["otp"]) {
            $this->context->cookie->__set('opt', 1);

          }
          if (isset($retour["cvc"]) && $retour["cvc"] && Configuration::get(self::CENTRALPAY . 'FORCECVC')==0) {
            $this->context->cookie->__set('cvc', 1);

          }


          $link = $this->context->link->getModuleLink(self::NOM_MODULE, '3dsiframe');
          Tools::redirect($link);
          exit();


        }

        if (isset($retour["otp"]) && $retour["otp"]) {

          if (isset($retour["cvc"]) && $retour["cvc"] && Configuration::get(self::CENTRALPAY . 'FORCECVC')==0) {
            $this->context->cookie->__set('cvc', 1);

          }

          $otp[self::CUSTOMER_ID] = $customerid;
          $otp['provider'] = Configuration::get(self::CENTRALPAY . 'PROVIDER');
          $otp[self::CURRENCY] = $currency->iso_code;
          $otp[self::AMOUNT] = intval($panier->getordertotal(TRUE) * 100);
          $otpfields = isset($otp) ? http_build_query($otp) : NULL;
          $curl = curl_init();
          curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid . "/otp");
          curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($curl, CURLOPT_POSTFIELDS, $otpfields);
          curl_setopt($curl, CURLOPT_POST, 1);
          curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
          curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
          $result = curl_exec($curl);
          $info = curl_getinfo($curl);
          $retour = json_decode($result, 1);
          curl_close($curl);

          $this->context->cookie->__set(self::CARD_ID, $cardId);
          $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
          $this->context->cookie->__set(self::TRANSACTION, json_encode($trans));
          $this->context->cookie->__set(self::SAVE_CARD, 1);
          $link = $this->context->link->getModuleLink(self::NOM_MODULE, 'otp');
          Tools::redirect($link);
          exit();


        }

        if (isset($retour["cvc"]) && $retour["cvc"] && Configuration::get(self::CENTRALPAY . 'FORCECVC')==0) {


          $this->context->cookie->__set(self::CARD_ID, $cardId);
          $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
          $this->context->cookie->__set(self::TRANSACTION, json_encode($trans));
          $this->context->cookie->__set(self::SAVE_CARD, Tools::getValue(self::SAVE_CARD));
          $link = $this->context->link->getModuleLink(self::NOM_MODULE, 'cvc');
          Tools::redirect($link);
          exit();


        }

      }
      else {

        //on transforme le panier en commande erreur de paiement
        $link = $this->errorCommande();
        Tools::redirect($link);

      }
    }
    else {

      //on transforme le panier en commande erreur de paiement
      $link = $this->errorCommande();
      Tools::redirect($link);
    }

  }

  public function errorCommande() {


    $link = $this->context->link->getModuleLink(self::NOM_MODULE, 'error');
    Tools::redirect($link);
    exit();


  }

}