<?php

class CentralpayTransactionProcessModuleFrontController extends ModuleFrontController {

  protected $msg = "";

  protected $title = "";

  protected $cardId = "";

  const CENTRALPAY = '_CENTRALPAY_';

  const CUSTOMER_ID = 'customerId';

  const CARD_TOKEN_ID = 'cardTokenId';

  const SAVE_CARD = 'saveCard';

  const AMOUNT = 'amount';

  const CURRENCY = 'currency';

  const HTTP_CODE = 'http_code';

  const NOM_MODULE = 'centralpay';

  const TRANSACTION = 'transaction';

  const RETOUR_3DS = 'retour3DS';

  const CARD_ID = 'cardId';

  const CHECK_ENROLLMENT = 'checkEnrollment';

  const DEFAULT_CONST = 'default';

  const ERRORS = 'errors';

  const FIRST6 = 'first6';

  const LAST4 = 'last4';

  const EXPIRATION_MONTH = 'expirationMonth';

  const EXPIRATION_YEAR = 'expirationYear';

  const CENTRALPAY_CARD_TABLE = 'centralpay_card';

  const CARDS = 'cards';

  const COMMERCIAL_BRAND = 'commercialBrand';

  const CUSTOMER_VALIDATION_VALUE = 'customerValidationValue';

  public function postProcess() {

    $this->context->cookie->__unset(self::TRANSACTION);
    $this->context->cookie->__unset(self::CARD_ID);
    $this->context->cookie->__unset(self::CUSTOMER_VALIDATION_VALUE);
    $this->context->cookie->__unset(self::RETOUR_3DS);
    $this->context->cookie->__unset('opt');
    $this->context->cookie->__unset('cvc');


    $hasError = FALSE;
    $txtError = '';
    $this->cardId = $this->context->cart->id;
    $panier = $this->context->cart;
    $currency = new Currency($panier->id_currency);
    $address = new Address($this->context->cart->id_address_delivery);
    $client = new Customer($panier->id_customer);
    $country = new Country($address->id_country);
    $customerValidationValue = Tools::getValue("CVV");

    $sql = 'SELECT * FROM ' . _DB_PREFIX_ . 'module WHERE name=\'' . pSQL(self::NOM_MODULE) . '\'';
    $results = Db::getInstance()->ExecuteS($sql);

    if (Configuration::get(self::CENTRALPAY . 'MODE_TEST') == 1) {
      $url_api = API_TEST;

    }
    else {
      $url_api = API;

    }

    $id_module = $results[0]["id_module"];


    /**
     * IDENTIFICATION API CENTRALPAY
     */
    $userpwd = Configuration::get(self::CENTRALPAY . 'LOGIN') . ":" . Configuration::get(self::CENTRALPAY . 'PASSWORD');

    /**
     * ADRESSE IP DU CLIENT
     */
    if (Configuration::get(self::CENTRALPAY . 'MODE_TEST') == 1) {
      //si on est en mode de test on récupère l'adresse IP renseigné dans le BO
      $adresse_ip = Configuration::get(self::CENTRALPAY . 'IP');
    }
    else {
      $adresse_ip = $_SERVER["REMOTE_ADDR"];
    }


    /**
     * On vérifie si le compte client actuel est lié à un customer
     */

    $sql = 'SELECT ' . self::CUSTOMER_ID . ' FROM ' . _DB_PREFIX_ . 'centralpay_customer WHERE cmsCustomerId=' . intval($panier->id_customer);
    $results = Db::getInstance()->ExecuteS($sql);
    /**
     * Si un customer est rattaché au client actuel on met à jour le customer centralpay
     */
    if (isset($results[0])) {


      $customerid = $results[0][self::CUSTOMER_ID];


      /**
       * Mise à jour du customer
       */
      $country = new Country($address->id_country);


      $cust["merchantCustomerId"] = $panier->id_customer;
      $cust["firstName"] = $address->firstname;
      $cust["lastName"] = $address->lastname;
      $cust["adressLine1"] = $address->address1;
      $cust["adressLine2"] = $address->address2;
      $cust["adressLine3"] = '';
      $cust["adressLine4"] = '';
      $cust["postalCode"] = $address->postcode;
      $cust["city"] = $address->city;
      $cust["country"] = $country->iso_code;
      $cust["email"] = $client->email;
      $cust["phone"] = $address->phone;


      $custfields = isset($cust) ? http_build_query($cust) : NULL;


      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

      $result = curl_exec($curl);
      $info = curl_getinfo($curl);

      /**
       * Enregistrement de la carte via l'api Centralpay
       */

      $cust[self::CARD_TOKEN_ID] = Tools::getValue(self::CARD_TOKEN_ID);
      $cust[self::CUSTOMER_ID] = $customerid;
      $custfields = isset($cust) ? http_build_query($cust) : NULL;

      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "card/");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);

      if (isset($retour[self::ERRORS])) { // Error message

        $hasError = TRUE;
        $txtError = 'Error enregistrement carte';
      }
      else {


        $card = json_decode($result, 1);

        /**
         * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
         */
        if (Tools::getValue(self::SAVE_CARD) == 1) {

          /**
           * On mets les autres carte à défaut non
           */
          Db::getInstance()
            ->update(self::CENTRALPAY_CARD_TABLE, [self::DEFAULT_CONST => 0], 'customerId=\'' . pSQL($customerid) . '\'');

          Db::getInstance()->insert(self::CENTRALPAY_CARD_TABLE, [
            self::CARD_ID => pSQL($card[self::CARD_ID]),
            self::CUSTOMER_ID => pSQL($customerid),
            self::COMMERCIAL_BRAND => pSQL($card[self::COMMERCIAL_BRAND]),
            self::FIRST6 => pSQL($card[self::FIRST6]),
            self::LAST4 => pSQL($card[self::LAST4]),
            self::DEFAULT_CONST => 1,
            self::CARD_TOKEN_ID => pSQL($card[self::CARD_TOKEN_ID]),
            self::EXPIRATION_YEAR => pSQL($card[self::EXPIRATION_YEAR]),
            self::EXPIRATION_MONTH => pSQL($card[self::EXPIRATION_MONTH]),
          ]);
        }
        $cardId = $card[self::CARD_ID];

      }


    }
    else {
      /**
       * Si aucun customer n'est rattaché au client actuel on crée le customer
       */


      $cust[self::CARD_TOKEN_ID] = Tools::getValue(self::CARD_TOKEN_ID);
      $cust["merchantCustomerId"] = $panier->id_customer;
      $cust["firstName"] = $address->firstname;
      $cust["lastName"] = $address->lastname;
      $cust["adressLine1"] = $address->address1;
      $cust["adressLine2"] = $address->address2;
      $cust["adressLine3"] = '';
      $cust["adressLine4"] = '';
      $cust["postalCode"] = $address->postcode;
      $cust["city"] = $address->city;
      $cust["country"] = $country->iso_code;
      $cust["email"] = $client->email;
      $cust["phone"] = $address->phone;

      $custfields = isset($cust) ? http_build_query($cust) : NULL;


      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer");
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $custfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);

      $result = curl_exec($curl);
      $info = curl_getinfo($curl);


      $retour = json_decode($result, 1);

      if (isset($retour[self::ERRORS])) { /// Error message
        curl_close($curl);
        $hasError = TRUE;
        $txtError = 'Error enregistrement customer';
      }
      else {

        $customer = json_decode($result, 1);
        $customerid = $customer[self::CUSTOMER_ID];
        /**
         * Enregistrement du lien en le client prestashop et le customer centralpay
         */
        Db::getInstance()->insert('centralpay_customer', [
          self::CUSTOMER_ID => pSQL($customer[self::CUSTOMER_ID]),
          'cmsCustomerId' => pSQL($panier->id_customer),
        ]);
        /**
         * Enregistrement de la carte dans la base de données , carte par défaut si checkbox cochée
         */
        if (Tools::getValue(self::SAVE_CARD) == 1) {

          Db::getInstance()->insert(self::CENTRALPAY_CARD_TABLE, [
            self::CARD_ID => pSQL($customer[self::CARDS][0][self::CARD_ID]),
            self::CUSTOMER_ID => pSQL($customer[self::CUSTOMER_ID]),
            self::COMMERCIAL_BRAND => pSQL($customer[self::CARDS][0][self::COMMERCIAL_BRAND]),
            self::FIRST6 => pSQL($customer[self::CARDS][0][self::FIRST6]),
            self::LAST4 => pSQL($customer[self::CARDS][0][self::LAST4]),
            self::DEFAULT_CONST => 1,
            self::CARD_TOKEN_ID => pSQL($customer[self::CARDS][0][self::CARD_TOKEN_ID]),
            self::EXPIRATION_YEAR => pSQL($customer[self::CARDS][0][self::EXPIRATION_YEAR]),
            self::EXPIRATION_MONTH => pSQL($customer[self::CARDS][0][self::EXPIRATION_MONTH]),
          ]);
        }
        $cardId = $customer[self::CARDS][0][self::CARD_ID];

      }


    }

    /**
     * Si paiement configuré pour le 3DS
     */
    if (!$hasError && Configuration::get(self::CENTRALPAY . '3DS') == 1) {

      $enrolement['merchantTransactionIdentifier'] = $this->context->cart->id;
      $enrolement['merchantName'] = Configuration::get('PS_SHOP_NAME');
      $enrolement['merchantCountry'] = Configuration::get(self::CENTRALPAY . 'MERCHANTCOUNTRY');
      $enrolement['merchantURL'] = $_SERVER["REQUEST_SCHEME"] . '://' . $_SERVER["HTTP_HOST"];
      $enrolement[self::CURRENCY] = $currency->iso_code;
      $enrolement[self::AMOUNT] = intval(Tools::getValue(self::AMOUNT));
      $enrolement[self::CARD_ID] = $cardId;
      $enrolement[self::CUSTOMER_ID] = $customerid;

      $enrolementfields = isset($enrolement) ? http_build_query($enrolement) : NULL;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . self::CHECK_ENROLLMENT);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $enrolementfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);


      //erreur sur le retour de l'appel à l'api
      if ($info[self::HTTP_CODE] != 200 || (isset($retour["statuts"]) && $retour["statuts"] == 'FAILURE')) {
        $link = $this->errorCommande();
        Tools::redirect($link);

        exit();

      }
      $this->context->cookie->__set(self::RETOUR_3DS, $result);
      $this->context->cookie->__set(self::CARD_ID, $cardId);
      $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
      $link = $this->context->link->getModuleLink(self::NOM_MODULE, '3dsiframe');
      Tools::redirect($link);

      exit();

    }

    /**
     * Création de la transaction
     */
    if (!$hasError) {

      global $cookie;
      $iso_code = Language::getIsoById( (int)$cookie->id_lang );
      $trans[self::CURRENCY] = $currency->iso_code;
      $trans[self::AMOUNT] = intval(Tools::getValue(self::AMOUNT));
      $trans[self::CUSTOMER_ID] = $customerid;
      $trans[self::CARD_ID] = $cardId;
      $trans['merchantTransactionId'] = $panier->id;
      $trans['endUserLanguage']=$iso_code;
      $trans['pointOfSaleId'] = Configuration::get(self::CENTRALPAY . 'POINTOFSALEID');
      $trans['endUserIp'] = $adresse_ip;


      $transfields = isset($trans) ? http_build_query($trans) : NULL;
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, trim($url_api) . self::TRANSACTION);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $transfields);
      curl_setopt($curl, CURLOPT_POST, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
      $result = curl_exec($curl);
      $info = curl_getinfo($curl);
      $retour = json_decode($result, 1);
      curl_close($curl);

      /**
       * Vérification de l'état de la transaction
       */

      if (isset($info[self::HTTP_CODE]) && $info[self::HTTP_CODE] == 200 && isset($retour["authorizationStatus"]) && $retour["authorizationStatus"] == 'SUCCESS') {
        //transaction ok
        //on transforme le panier en commande validée et payée
        $cart = new Cart((int) $panier->id);
        $order_status = (int) Configuration::get('PS_OS_PAYMENT');
        $order_total = $cart->getOrderTotal(TRUE, Cart::BOTH);
        $this->module->validateOrder($panier->id, $order_status, $order_total, "Centralpay payment", NULL, ['transaction_id' => $retour["transactionId"]], NULL, FALSE, $panier->secure_key);
        /**
         * Enregistrement de la liaison entre le paiement et la carte centralpay
         */
        $orderid = Order::getOrderByCartId((int) ($cart->id));

        $order = new Order($orderid);

        $sql = 'SELECT * FROM ' . _DB_PREFIX_ . 'order_payment WHERE order_reference=\'' . pSQL($order->reference) . '\'';
        $results = Db::getInstance()->ExecuteS($sql);
        if (is_array($results)) {
          foreach ($results as $r) {
            if ($r["transaction_id"] == $retour["transactionId"] && Tools::getValue(self::SAVE_CARD) == 1) {
              /**
               * Enregistrement du lient entre la carte et le paiement Prestashop si la carte a été sauvegardée
               */


              Db::getInstance()->insert('centralpay_payment_card', [
                self::CARD_ID => pSQL($cardId),
                'cmsPaymentId' => pSQL($r["id_order_payment"]),
              ]);


            }


          }


        }
        $link = 'index.php?controller=order-confirmation&id_cart=' . $order->id_cart
          . '&id_module=' . $id_module . '&id_order=' . $order->id
          . '&key=' . $order->secure_key;
        Tools::redirect($link);


      }
      elseif (isset($info[self::HTTP_CODE]) && $info[self::HTTP_CODE] == 307) {
        //on vérifie si on doit faire une transtion pas 3ds
        // si opt est à false et checkrenfollment alors 3ds


        $retour = json_decode($result, 1);


        if (is_array($retour[self::CHECK_ENROLLMENT])) {
          $this->context->cookie->__set(self::RETOUR_3DS, json_encode($retour[self::CHECK_ENROLLMENT]));
          $this->context->cookie->__set(self::CARD_ID, $cardId);
          $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
          $this->context->cookie->__set(self::SAVE_CARD, Tools::getValue(self::SAVE_CARD));
          $this->context->cookie->__set(self::TRANSACTION, json_encode($trans));
          if (isset($retour["otp"]) && $retour["otp"]) {
            $this->context->cookie->__set('opt', 1);

          }
          if (isset($retour["cvc"]) && $retour["cvc"]) {
            $this->context->cookie->__set('cvc', 1);

          }

          $link = $this->context->link->getModuleLink(self::NOM_MODULE, '3dsiframe');
          Tools::redirect($link);
          exit();


        }

        if (isset($retour["otp"]) && $retour["otp"]) {

          if (isset($retour["cvc"]) && $retour["cvc"]) {
            $this->context->cookie->__set('cvc', 1);

          }

          $otp[self::CUSTOMER_ID] = $customerid;
          $otp['provider'] = Configuration::get(self::CENTRALPAY . 'PROVIDER');
          $otp[self::CURRENCY] = $currency->iso_code;
          $otp[self::AMOUNT] = intval(Tools::getValue(self::AMOUNT));
          $otpfields = isset($otp) ? http_build_query($otp) : NULL;
          $curl = curl_init();
          curl_setopt($curl, CURLOPT_URL, trim($url_api) . "customer/" . $customerid . "/otp");
          curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($curl, CURLOPT_POSTFIELDS, $otpfields);
          curl_setopt($curl, CURLOPT_POST, 1);
          curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
          curl_setopt($curl, CURLOPT_USERPWD, $userpwd);
          $result = curl_exec($curl);
          $info = curl_getinfo($curl);
          $retour = json_decode($result, 1);
          curl_close($curl);

          $this->context->cookie->__set(self::CARD_ID, $cardId);
          $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
          $this->context->cookie->__set(self::TRANSACTION, json_encode($trans));
          $this->context->cookie->__set(self::SAVE_CARD, Tools::getValue(self::SAVE_CARD));
          $link = $this->context->link->getModuleLink(self::NOM_MODULE, 'otp');
          Tools::redirect($link);
          exit();


        }

        if (isset($retour["cvc"]) && $retour["cvc"]) {


          $this->context->cookie->__set(self::CARD_ID, $cardId);
          $this->context->cookie->__set(self::CUSTOMER_VALIDATION_VALUE, $customerValidationValue);
          $this->context->cookie->__set(self::TRANSACTION, json_encode($trans));
          $this->context->cookie->__set(self::SAVE_CARD, Tools::getValue(self::SAVE_CARD));
          $link = $this->context->link->getModuleLink(self::NOM_MODULE, 'cvc');
          Tools::redirect($link);
          exit();


        }

      }
      else {
        //on transforme le panier en commande erreur de paiement
        $link = $this->errorCommande();
        Tools::redirect($link);

      }


      if (isset($retour[self::ERRORS])) {  // Error message
        $txtError = 'Error enregistrement transaction';

      }

    }
    else {

      //on transforme le panier en commande erreur de paiement
      $link = $this->errorCommande();
      Tools::redirect($link);
    }


  }

  public function errorCommande() {


    $link = $this->context->link->getModuleLink(self::NOM_MODULE, 'error');
    Tools::redirect($link);
    exit();


  }


}