var cardIcon = [{
    type: "cc-maestro",
    patterns: [5018, 502, 503, 506, 56, 58, 639, 6220, 67],
    length: [12, 13, 14, 15, 16, 17, 18, 19]
}, {
    type: "cc-forbrugsforeningen",
    patterns: [600],
    length: [16]
}, {
    type: "cc-dankort",
    patterns: [5019],
    length: [16]
}, {
    type: "cc-visa",
    patterns: [4],
    length: [13, 16]
}, {
    type: "cc-mastercard",
    patterns: [51, 52, 53, 54, 55, 22, 23, 24, 25, 26, 27],
    length: [16]
}, {
    type: "cc-amex",
    patterns: [34, 37],
    length: [15]
}, {
    type: "cc-diners-club",
    patterns: [30, 36, 38, 39],
    length: [14]
}, {
    type: "cc-discover",
    patterns: [60, 64, 65, 622],
    length: [16]
}, {
    type: "cc-unionpay",
    patterns: [62, 88],
    length: [16, 17, 18, 19]
}, {
    type: "cc-jcb",
    patterns: [35],
    length: [16]
}];

var display = {
    endUserLanguage : function() {
        var browserLanguages, userLanguage;

        /* method "navigator.languages" is not implemented in all browsers */
        if (navigator.languages) {
            browserLanguages = navigator.languages[0];
        } else {
            browserLanguages = navigator.language;
        }
        userLanguage = browserLanguages.substr(0, 2);

        return userLanguage;
    },
    errorMessages :
        [
            {
                en : 'An error occurred',
                fr : 'Une erreur est survenue',
                es : 'Ha ocurrido un error',
                it : 'Si è verificato un errore',
                de : 'Ein Fehler ist aufgetreten',
                ru : 'Произошла ошибка'
            },
            {
                en : 'Invalid card number',
                fr : 'Numéro de carte invalide',
                es : 'Número de tarjeta no válido',
                it : 'Numero di carta non valido',
                de : 'Ungültige Kartennummer',
                ru : 'не верный номер карты'
            },
            {
                en : 'Card type not supported',
                fr : 'Type de carte non pris en charge',
                es : 'Tipo de tarjeta no soportado',
                it : 'Tipo di carta non supportato',
                de : 'Kartentyp wird nicht unterstützt',
                ru : 'Тип карты не поддерживается'
            },
            {
                en : 'Required fields are missing',
                fr : 'Champs obligatoires vides',
                es : 'Campos requeridos en blanco',
                it : 'Campi obbligatori vuoti',
                de : 'Erforderliche Felder leer',
                ru : 'обязательные поля пусты'
            },
            {
                en : 'Illegal value for parameter',
                fr : 'Valeur de paramètre incorrecte',
                es : 'Valor de parámetro no valido',
                it : 'Valore del parametro non valido',
                de : 'Ungültiger Parameterwert',
                ru : 'Недопустимое значение параметра'
            },
            {
                en : 'Card expired',
                fr : 'Carte expirée',
                es : 'Tarjeta caducada',
                it : 'Carta scaduta',
                de : 'Karte abgelaufen',
                ru : 'Срок действия карты истек'
            },
            {
                en : 'Empty or invalid CVC',
                fr : 'CVC vide ou invalide',
                es : 'CVC vacío o no válido',
                it : 'CVC vuoto o non valido',
                de : 'Leere oder ungültige CVC',
                ru : 'Пустой или недопустимый CVC'
            }
        ],
    translate : function (text) {
        for (var i = 0; i < display.errorMessages.length; i++) {
            if (text === display.errorMessages[i].en) {
                if (typeof display.errorMessages[i][display.endUserLanguage()] === 'string') {
                    text = display.errorMessages[i][display.endUserLanguage()];
                }
            }
        }
        return text;
    }
};

function iconCard(number) {
    // Remove spaces and hyphens
    number = (number + "").replace(/\s+|-/g, "");
    var card, p, pattern, i, j, len, len1, ref;
    for (i = 0, len = cardIcon.length; i < len; i++) {
        card = cardIcon[i];
        ref = card.patterns;
        for (j = 0, len1 = ref.length; j < len1; j++) {
            pattern = ref[j];
            p = pattern + "";
            if (number.substr(0, p.length) === p) {
                return card.type;
            }
        }
    }
}


function updateCardNumberIcon() {
    var num = document.getElementById("num");
    var parentNode = num.parentNode;
    // Remove existing cardIcon
    var cardIcon = parentNode.querySelector('.cardIcon');
    if (cardIcon) {
        parentNode.removeChild(cardIcon);
    }
    var newCardIcon = iconCard(num.value);
    if (newCardIcon) {
        // New cardIcon
        var spanIcon = document.createElement('span');
        spanIcon.className = "cardIcon "+newCardIcon;
        parentNode.appendChild(spanIcon);
    }
    if(jQuery('#num').val().length==19){
        jQuery("#month").focus();

    }
}

var champsForm;
function setMask(){
    if( jQuery("#num").length>0){
        initForm();
        jQuery("#num").payment("formatCardNumber");
        jQuery("#month").inputmask('Regex',{ regex : "^(0[1-9]|1[0-2])$" });
        jQuery("#year").inputmask('Regex',{ regex : "^[0-9][0-9]$" });
        jQuery("#cvv2").payment("formatCardCVC");
        jQuery("#cvv3").payment("formatCardCVC");
        clearInterval(champsForm);
    }
}

var currentForm;
var defaultHandlerCP = function (status, response) {

    var divErrors = document.querySelector('[data-centralpay="errors"]');
    divErrors.innerHTML = "";
    var hasError = false;
    $('.error').remove();
    if (status != 200) { // Error
        var ulErrors = document.createElement('ul');
        var liErrors;
        if (status == 400) {
            var json = JSON.parse(response);
            if (json && json.errors) { // Bad Request with json response errors
                for (var key in json.errors) {
                    if(key==='card[*]' || key==='card[expirationMonth]' || key==='card[expirationYear]'){
                        jQuery('#cpay-exp-wrapper').parent().after('<div class="error">'+display.translate(json.errors[key])+'</div>');
                    }
                    if(key==='card[cvc]'){
                        jQuery('#div_cvv').after('<div class="error">'+display.translate(json.errors[key])+'</div>');
                    }
                    if(key==='card[number]'){
                        jQuery('#num_carte .input-group').after('<div class="error">'+display.translate(json.errors[key])+'</div>');
                    }
                }
            }
            else {
                // Other errors
                liErrors = document.createElement('li');
                liErrors.appendChild(document.createTextNode(display.translate(display.errorMessages[0].en)));
                ulErrors.appendChild(liErrors);
                hasError = true;
            }
        }
        else {
            // Other errors
            liErrors = document.createElement('li');
            liErrors.appendChild(document.createTextNode(display.translate(display.errorMessages[0].en)));
            ulErrors.appendChild(liErrors);
            hasError = true;
        }
        if(hasError) {
            divErrors.appendChild(ulErrors);
        } else {
            $('.payment-errors').html('');
        }
        // Re-enable submission
        jQuery('[type="submit"]').removeAttr('disabled');


    }
    else {
        // Token was created
        var token = JSON.parse(response);
        // Insert cardTokenId in the form
        var inputTokenId = document.createElement('input');
        inputTokenId.setAttribute('type', 'hidden');
        inputTokenId.setAttribute('name', 'cardTokenId');
        inputTokenId.value = token.cardTokenId;
        document.querySelector('form[data-centralpay="form"]').appendChild(inputTokenId);
        // Remove submit event
        document.querySelector('form[data-centralpay="form"]').removeEventListener('submit', defaultHandlerCP);
        // Submit the form



        document.querySelector('form[data-centralpay="form"]').submit();
    }
};


function initForm(){

    var form = document.querySelector('form[data-centralpay="form"]');
    if (form && form.nodeName === "FORM") {
        form.addEventListener('submit', function(e) {
            // Prevent other event listener
            Centralpay.utils.safePreventEvent(e);
            // Disable the submit button of the form to prevent repeated clicks
            jQuery('[type="submit"]').attr('disabled', 'disabled');
            // Request a token from Centralpay
            $('.error').remove();
            if($('#conditions-to-approve').length>0){

              //  console.log($('#conditions-to-approve').is(':checked'));
                if(!$("input[name='conditions_to_approve[terms-and-conditions]']").prop('checked')){
                    jQuery('[type="submit"]').removeAttr('disabled');
                    $("input[name='conditions_to_approve[terms-and-conditions]']").parent().parent().parent().after('<div class="error" style="font-size: 14px;">'+alert_cgv+'</div>');
                    $('html, body').animate({
                        scrollTop: $("input[name='conditions_to_approve[terms-and-conditions]']").offset().top
                    }, 2000);
                    return false;
                }


            }


            Centralpay.card.createToken(form, defaultHandlerCP);
            return false;
        });
    }

}


$(document).ready(function () {


    $('#div_list').on('submit','#card-form',function(e){
        $('.error').remove();
        if($('#conditions-to-approve').length>0){


            console.log($("input[name='conditions_to_approve[terms-and-conditions]']").prop('checked'));
            if(!$("input[name='conditions_to_approve[terms-and-conditions]']").prop('checked')){
                e.preventDefault();
                jQuery('[type="submit"]').removeAttr('disabled');
                $("input[name='conditions_to_approve[terms-and-conditions]']").parent().parent().parent().after('<div class="error" style="font-size: 14px;">'+alert_cgv+'</div>');
                $('html, body').animate({
                    scrollTop: $("input[name='conditions_to_approve[terms-and-conditions]']").offset().top
                }, 2000);

                return false;
            }


        }


    })


    window.Centralpay ? Centralpay.card.setMerchantPublicKey(MerchantPublicKey):'';
    initForm();

    var content = jQuery('.content');

    content.on('click','#link_centralpay',function() {
        jQuery('#div_centralpay').slideDown("slow");
    });

    content.on("keyup",'#num', updateCardNumberIcon);
    content.on("keyup",'#month', function(){
        if(jQuery(this).val().length==2){
            jQuery("#year").focus();
        }
    });
    content.on("keyup",'#year', function(){

        if(jQuery(this).val().length==2 && $(this).val().indexOf('_')==-1 ){

            jQuery("#cvv2").focus();
        }

    });

    if ($('#div_list').length > 0) {
        $('#div_list').html('<form action="' + url_form_action + '" method="POST" id="card-form" class="box">' + $('#div_list').html() + '</form>');
    }

    jQuery('#cgv').on('click',function(){
        if(jQuery(this).prop('checked')==true){
            champsForm =  setInterval(function(){
                setMask();
            }, 1000);
        }
    });

    // Si CentralPay est le mode de paiement sélectionné, masquer le bouton de paiement de PrestaShop car celui du
    // plugin prend le relai
    var paymentOptionRadioButton = jQuery('input[name="payment-option"]');
    jQuery(paymentOptionRadioButton).click(function() {

        var moduleNameAttr = $(this).attr('data-module-name');

        if ( typeof moduleNameAttr !== typeof undefined && moduleNameAttr !== false && moduleNameAttr === 'module-centralpay' ) {
            $('#payment-confirmation').addClass('cpay-hidden');
        } else {
            $('#payment-confirmation').removeClass('cpay-hidden');
        }
    });

    jQuery('a[title]').qtip({position: {my: 'bottom center', at: 'top center'}});

    jQuery("#num").payment("formatCardNumber");
    jQuery("#month").inputmask('Regex',{ regex : "^(0[1-9]|1[0-2])$" });
    jQuery("#year").inputmask('Regex',{ regex : "^[0-9][0-9]$" });
    jQuery("#cvv2").payment("formatCardCVC");
    jQuery("#cvv3").payment("formatCardCVC");
});
