{*
* 2007-2016 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2016 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*}
{extends file='page.tpl'}
{block name='page_title'}
    {l s='My credit cards' mod='centralpay'}
{/block}
{block name='page_content'}

    {if $cards && count($cards)}
    <table class="table table-striped table-bordered table-labeled hidden-sm-down">
        <thead class="thead-default">
        <tr>
            <th>{l s='Card number' mod='centralpay'}</th>
            <th>{l s='Commercial brand' mod='centralpay'}</th>
            <th>{l s='Expiration date' mod='centralpay'}</th>
            <th>{l s='Default' mod='centralpay'}</th>
            <th>{l s='Action' mod='centralpay'}</th>
        </tr>
        </thead>
        <tbody>
        {foreach from=$cards item=card name=myLoop}
            <tr class="{if $smarty.foreach.myLoop.first}first_item{elseif $smarty.foreach.myLoop.last}last_item{else}item{/if} {if $smarty.foreach.myLoop.index % 2}alternate_item{/if}">
                <td>{$card.first6}---------{$card.last4}</td>
                <td>{$card.commercialBrand}</td>
                <td>{$card.expirationMonth}/{$card.expirationYear}</td>
                <td>{if $card.default==1}{l s='Yes'}{/if}</td>
                <td>
                    <a class="btn btn-default button button-small" href="?action=delete&card={$card.cardId}" title="{l s='Delete' mod='centralpay'}">
                        <span>{l s='Delete' mod='centralpay'}</span>
                    </a>&nbsp;&nbsp;
                    <a class="link-button" href="?action=default&card={$card.cardId}" title="{l s='Set as default' mod='centralpay'}">
                        <i class="icon-refresh"></i>{l s='Default' mod='centralpay'}
                    </a>

                </td>

            </tr>
        {/foreach}
        </tbody>
    </table>
    {else}
        <p class="alert alert-warning">{l s='You have not registered any credit cards.' mod='centralpay'}</p>
    {/if}

{/block}

{block name='page_footer'}
    {block name='my_account_links'}
        {include file='customer/_partials/my-account-links.tpl'}
    {/block}
{/block}